--[[if select(2, UnitClass('player')) ~= "HUNTER" then
	DisableAddOn("Watcher")
	return
end]]

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
Watcher = AceAddon:NewAddon("Watcher", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SCT = SCT
local REVISION = tonumber(("$Revision: 5 $"):match("%d+"))
local _, _, _, clientVersion = GetBuildInfo()
if clientVersion >= 30100 then
	Watcher.patch31 = true
else
	Watcher.patch31 = false
end
Watcher.constants = {}
local C = Watcher.constants -- Defined in Watcher LUA no locale needed.

C["Serpent Sting"], _, C["Serpent Sting Icon"] = GetSpellInfo(49001)
C["Explosive Shot"], _, C["Explosive Shot Icon"] = GetSpellInfo(60053)
C["Aimed Shot"], _, C["Aimed Shot Icon"] = GetSpellInfo(49050)
C["Lock and Load"], _, C["Lock and Load Icon"] = GetSpellInfo(56453)
C["Beast Lore"], _, C["Beast Lore Icon"] = GetSpellInfo(1462)
C["Black Arrow"], _, C["Black Arrow Icon"] = GetSpellInfo(63672)
C["Kill Shot"], _, C["Kill Shot Icon"] = GetSpellInfo(61006)
C["Steady Shot"], _, C["Steady Shot Icon"] = GetSpellInfo(49052)
C["Arcane Shot"], _, C["Arcane Shot Icon"] = GetSpellInfo(49045)
C["Chimera Shot"], _, C["Chimera Shot Icon"] = GetSpellInfo(53209)
C["Multi-Shot"], _, C["Multi-Shot Icon"] = GetSpellInfo(49048)
C["Aspect of the Dragonhawk"], _, C["Aspect of the Dragonhawk Icon"] = GetSpellInfo(61847)
C["Aspect of the Viper"], _, C["Aspect of the Viper Icon"] = GetSpellInfo(34074)
C["Hunter's Mark"], _, C["Hunter's Mark Icon"] = GetSpellInfo(53338)
C["Rapid Fire"], _, C["Rapid Fire Icon"] = GetSpellInfo(3045)
C["Bestial Wrath"], _, C["Bestial Wrath Icon"] = GetSpellInfo(19574)
C["Blood Fury"], _, C["Blood Fury Icon"] = GetSpellInfo(20572)
C["Readiness"], _, C["Readiness Icon"] = GetSpellInfo(23989)

local combat
Watcher.textures = {}
Watcher.borders = {}
Watcher.fonts = {}
Watcher.sounds = {}
Watcher.dir = {"right", "down", "left", "up"}


Watcher.PriorityFrame = CreateFrame("Frame", "SAA_PriorityFrame", UIParent)
Watcher.PriorityFrame.axisbase = CreateFrame("Frame", "SAA_PriorityFrameAB", Watcher.PriorityFrame)
Watcher.Priority1 = CreateFrame("Frame", "SAA_PriorityFrame1", Watcher.PriorityFrame)
Watcher.Priority2 = CreateFrame("Frame", "SAA_PriorityFrame2", Watcher.PriorityFrame)
Watcher.Priority3 = CreateFrame("Frame", "SAA_PriorityFrame3", Watcher.PriorityFrame)
Watcher.Priority4 = CreateFrame("Frame", "SAA_PriorityFrame4", Watcher.PriorityFrame)
Watcher.Priority5 = CreateFrame("Frame", "SAA_PriorityFrame5", Watcher.PriorityFrame)
Watcher.Priority6 = CreateFrame("Frame", "SAA_PriorityFrame6", Watcher.PriorityFrame)
Watcher.Priority7 = CreateFrame("Frame", "SAA_PriorityFrame7", Watcher.PriorityFrame)
Watcher.Priority8 = CreateFrame("Frame", "SAA_PriorityFrame8", Watcher.PriorityFrame)
Watcher.PriorityGCD = CreateFrame("Frame", "SAA_PriorityFrameGCD", Watcher.PriorityFrame)
ready = {}
offset = 0

Watcher.PriorityFrame.axisbase.textmin = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
Watcher.PriorityFrame.axisbase.text = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")

Watcher.priorityTable = {}
Watcher.priorityTable.name = {}
Watcher.priorityTable.icon = {}
Watcher.priorityTable.check = {}

Watcher.defaults = {
	char = {
		message = "Welcome Home!",
		barshow = true,
		showraid = false,
		showparty = false,
		alpha = 1,
		balpha = 0.6,
		showcombat = false,
		showicons = true,
		relativeTo = "UIParent",
		relativePoint = "CENTER",
		point = "CENTER",
		texture = "Blizzard",
		barfont = "Friz Quadrata TT",
		barfontsize = 12,
		barfonteffect = "none",
		msgfont = "Friz Quadrata TT",
		msgfontsize = 24,
		msgfonteffect = "none",
		border = "none",
		barborder = "None",
		xOffset = 0,
		yOffset = -100,
		resetOn = true,
		scale = 1,
		showgcd = true,
		showaxis = true,
		growdir = "right",
		disablebars = false,
		debug = false,
		priority = {
			show = true,
			textshow = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			fWidth = 50,
			fHeight = 50,
			IconSize = 50,
			xOffset = -185,
			yOffset = -40,
			alpha = 0.4,
			--option[0] = {"gcd",},
			scale = 1,	
			option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			maxtime = 10,
			interval = 2,
		},
	},
}

Watcher.priorityTable.name["none"] = L["None"]
_, _, Watcher.priorityTable.icon["none"] = "Interface/Tooltips/UI-Tooltip-Background"
Watcher.priorityTable.check["none"] = function () return false end 
-------------
--Set Up / Event Functions
-------------
function Watcher:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")

	self.db = LibStub("AceDB-3.0"):New("WatcherDBPC", Watcher.defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Watcher", self:GetOptions(), {"Watcher", "saa"} )
	--media.RegisterCallback(self, "LibSharedMedia_Registered")
	
	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("Watcher","Watcher")
	self.optionsFrame[L["About"]] = LibStub("LibAboutPanel").new("Watcher", "Watcher")
	self.db:RegisterDefaults(self.defaults)
	self:SwitchTalents()
	self:CreatePriorityFrame()
	local version = GetAddOnMetadata("Watcher","Version")
	self.version = ("Watcher v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")

end

function Watcher:OnDisable()
    -- Called when the addon is disabled
end

function Watcher:OnEnable()
--	self:LibSharedMedia_Registered()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	
end

--[[function Watcher:LibSharedMedia_Registered()

	for k, v in pairs(media:List("statusbar")) do
		self.textures[v] = v
	end
	for k, v in pairs(media:List("border")) do
		self.borders[v] = v
	end
	for k, v in pairs(media:List("font")) do
		self.fonts[v] = v
	end
	for k, v in pairs(media:List("sound")) do
		self.sounds[v] = v
	end
end]]

function Watcher:PLAYER_ENTERING_WORLD()
	self.PriorityFrame:Show()
end

function Watcher:PLAYER_REGEN_DISABLED()
	combat = true
	self:CreatePriorityFrame()
end

function Watcher:PLAYER_REGEN_ENABLED()
	combat = false
	self:CreatePriorityFrame()
end

function Watcher:PLAYER_ENTERING_WORLD()
	self:CreatePriorityFrame()
end

function Watcher:DisplayVersion()
	self:Print(self.version)
end

function Watcher:PLAYER_TALENT_UPDATE()
	self:SwitchTalents()	
	self:CreatePriorityFrame()
end
	
function Watcher:SwitchTalents()	
	local points = GetUnspentTalentPoints(false, false, GetActiveTalentGroup())
	local groupIndex = GetActiveTalentGroup()
	if points > 0 and groupIndex == 1 then
		self.db.char.priority.option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self.db.char.priority.option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
	elseif points > 0 and groupIndex == 2 then
		self.db.char.priority.option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self.db.char.priority.option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
	else
		if groupIndex == 1 then 
			self.db.char.priority.option = self.db.char.priority.option1
		elseif groupIndex == 2 then 
			self.db.char.priority.option = self.db.char.priority.option2
		end
	end
	
end

function Watcher:CheckRaidParty()
	local raidnum = GetNumRaidMembers()
	local partynum = GetNumPartyMembers()
	if partynum > 0 and self.db.char.showparty == true then
		self.PriorityFrame:Show()
	elseif raidnum >= 1 and self.db.char.showraid == true then
		self.PriorityFrame:Show()
	else
		self.PriorityFrame:Hide()
	end
end

function Watcher:RAID_ROSTER_UPDATE()
	self:CreatePriorityFrame()
end

function Watcher:PARTY_MEMBERS_CHANGED()
	self:CreatePriorityFrame()
end

-------------------------------
-- Priority functions
-------------------------------
--GetTalentInfo(1, 1, false, false ,getactivetalentgroup) 

function Watcher:GetReady(optionnum)
	offset = 0
	for index = 1, optionnum do
		if ready[index] == true then
			offset = offset + 1
		end
	end
end

function Watcher:SetReadyPoint(FrameName, offset)
	if self.db.char.growdir == "right" then
			FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT", 0, (Watcher.db.char.priority.IconSize * 0.2) * (offset - 1))
	elseif self.db.char.growdir == "left" then
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT", 0, (Watcher.db.char.priority.IconSize * 0.2) * (offset - 1))
	elseif self.db.char.growdir == "up" then
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT", -(Watcher.db.char.priority.IconSize * 0.2) * (offset - 1), 0)
	elseif self.db.char.growdir == "down" then
			FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT", -(Watcher.db.char.priority.IconSize * 0.2) * (offset - 1), 0)
	end
end

function Watcher:MoveIcon(FrameName, timeleft)
	if self.db.char.growdir == "up" then 
		FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  0 , (timeleft * Watcher.db.char.priority.fWidth / 1.5))
	elseif self.db.char.growdir == "down" then 
		FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT",  0 , -(timeleft * Watcher.db.char.priority.fWidth / 1.5))
	elseif self.db.char.growdir == "right" then 
		FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT",  (timeleft * Watcher.db.char.priority.fWidth / 1.5) , 0)
	elseif self.db.char.growdir == "left" then 
		FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -(timeleft * Watcher.db.char.priority.fWidth / 1.5), 0)
	end
end

function Watcher:DurationString(duration)
    local string = (("%1.1f"):format(duration % 120)) .. "s";
    
    if (duration >= 120) then
        duration = floor(duration - (duration % 60)) / 60; -- minutes
        
        string = ((duration % 60) + 1) .."m " --.. string;
        
        if (duration >= 120) then
            duration = (duration - (duration % 60)) / 60; -- hours
            string = (duration + 1).. "h " --.. string;
        end
    end
    return string
end
--------------------------
--- Layout Functions
--------------------------
function Watcher:CreatePriorityFrame()
	self.PriorityFrame:ClearAllPoints()
	self.PriorityFrame:SetScale(self.db.char.scale)
	self.PriorityFrame:SetFrameStrata("BACKGROUND")
	self.PriorityFrame:SetAlpha(self.db.char.alpha)
	if self.db.char.growdir == "right" then
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "down" then
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "left" then
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "up" then
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
	end
	self.PriorityFrame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	})
	self.PriorityFrame:SetBackdropColor(0, 0, 0, self.db.char.balpha);
	self.PriorityFrame:SetMovable(true);
	self.PriorityFrame:RegisterForDrag("LeftButton");
	self.PriorityFrame:SetPoint(self.db.char.priority.point, self.db.char.priority.relativeTo, self.db.char.priority.relativePoint, self.db.char.priority.xOffset, self.db.char.priority.yOffset)
	self.PriorityFrame:SetScript("OnDragStart", 
		function()
			self.PriorityFrame:StartMoving();
		end );
	self.PriorityFrame:SetScript("OnDragStop",
		function()
			self.PriorityFrame:StopMovingOrSizing();
			self.PriorityFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(self.db.char.priority, self.PriorityFrame);
		end );
	if self.db.char.showgcd then
	Watcher:SetPriorityFrame(self.PriorityGCD,1)
	else
	self.PriorityGCD:Hide()
	end
	Watcher:SetPriorityFrame(self.Priority1,2)
	Watcher:SetPriorityFrame(self.Priority2,3)
	Watcher:SetPriorityFrame(self.Priority3,4)
	Watcher:SetPriorityFrame(self.Priority4,5)
	Watcher:SetPriorityFrame(self.Priority5,6)
	Watcher:SetPriorityFrame(self.Priority6,7)
	Watcher:SetPriorityFrame(self.Priority7,8)
	Watcher:SetPriorityFrame(self.Priority8,9)
	self:Axis()
	if self.db.char.showcombat == true then
		if combat == true then
			self.PriorityFrame:Show()
		else
			self.PriorityFrame:Hide()
		end
	else 
		self.PriorityFrame:Show()
	end
	if self.db.char.showraid == true or self.db.char.showparty == true then
		self:CheckRaidParty()
	end
end
	
function Watcher:AxisText()
	--Watcher.PriorityFrame.axisbase:Hide()
		--self.PriorityFrame.axisbase.text = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
		self.PriorityFrame.axisbase.textmin:SetFont(media:Fetch("font", self.db.char.barfont), self.db.char.barfontsize)
		self.PriorityFrame.axisbase.textmin:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize, -( self.db.char.barfontsize))
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize, -( self.db.char.barfontsize))
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,( self.db.char.barfontsize), Watcher.db.char.priority.IconSize)
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,( self.db.char.barfontsize), -Watcher.db.char.priority.IconSize)
		end
		self.PriorityFrame.axisbase.textmin:SetText(0)
		self.PriorityFrame.axisbase.text:SetFont(media:Fetch("font", self.db.char.barfont), self.db.char.barfontsize)
		self.PriorityFrame.axisbase.text:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axisbase.text:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5), -( self.db.char.barfontsize))
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame.axisbase.text:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5), -( self.db.char.barfontsize))
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame.axisbase.text:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,( self.db.char.barfontsize), Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5))
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame.axisbase.text:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,( self.db.char.barfontsize), -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5))
		end
		self.PriorityFrame.axisbase.text:SetText(self.db.char.priority.maxtime)
	end	


function Watcher:Axis()
	self.PriorityFrame.axisbase:ClearAllPoints()
	if not self.PriorityFrame.axis then
		self.PriorityFrame.axis = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
	end
	self.PriorityFrame.axisbase:ClearAllPoints()
	self.PriorityFrame.axis:ClearAllPoints()
	if self.db.char.growdir == "right" then
	self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * (self.db.char.priority.maxtime) / 1.5)
	self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "BOTTOMLEFT", Watcher.db.char.priority.IconSize, 0)
	elseif self.db.char.growdir == "left" then
	self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPRIGHT", self.PriorityFrame, "BOTTOMRIGHT", -Watcher.db.char.priority.IconSize, 0)
	elseif self.db.char.growdir == "down" then
	self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0, -Watcher.db.char.priority.IconSize)
	elseif self.db.char.growdir == "up" then
	self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0,0)
	end
	self.PriorityFrame.axis:SetTexture(1, 1, 1, 1)
	self.PriorityFrame.axis:Show()
	
	if not self.PriorityFrame.axisgcd then -- "Finish Line"
		self.PriorityFrame.axisgcd = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
	end
	--self.PriorityFrame.axisgcd:SetFrameLevel(10)
	self.PriorityFrame.axisgcd:ClearAllPoints()
	if self.db.char.growdir == "right" then
	self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",Watcher.db.char.priority.IconSize, 0)
	end
	if self.db.char.growdir == "left" then
	self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT",-Watcher.db.char.priority.IconSize, 0)
	end
	if self.db.char.growdir == "down" then
	self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("TOPRIGHT", self.PriorityFrame, "TOPRIGHT",0, -Watcher.db.char.priority.IconSize)
	end
	if self.db.char.growdir == "up" then
	self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",0, Watcher.db.char.priority.IconSize)
	end
	self.PriorityFrame.axisgcd:SetTexture(0, 0, 0, 1)
	self.PriorityFrame.axisgcd:Show()
	self:AxisText()
end

function Watcher:SetPriorityFrame(FrameName, optionnum)
	
	FrameName:ClearAllPoints()
	FrameName:SetFrameStrata("BACKGROUND")
	FrameName:SetFrameLevel(9 - optionnum)
	
	FrameName:SetWidth(Watcher.db.char.priority.IconSize)
	FrameName:SetHeight(self.db.char.priority.IconSize)
	
	if optionnum == 1 then
	FrameName:SetBackdrop({ bgFile = Watcher.priorityTable.icon[self.db.char.priority.option[optionnum]],
		edgeFile = "none",
		tile = false, tileSize = 0, edgeSize = 0,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }})
		FrameName:SetBackdropColor(0, 0, 0, 1);
	if self.db.char.growdir == "right" or "left" then
		FrameName:SetHeight(self.db.char.priority.fHeight / 3)
	end
	else
	FrameName:SetBackdrop({ bgFile = Watcher.priorityTable.icon[self.db.char.priority.option[optionnum]],
		edgeFile = "none",
		tile = false, tileSize = 0, edgeSize = 0,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }})
		FrameName:SetBackdropColor(1, 1, 1, 1);
		FrameName:SetAlpha(1)
	end
	if not FrameName.Text then
		FrameName.Text = FrameName:CreateFontString(nil, "OVERLAY")
	end
	FrameName.Text:SetTextColor(1,1,1,1)
	FrameName.Text:SetFont(media:Fetch("font", self.db.char.barfont), self.db.char.barfontsize)
	FrameName.Text:SetPoint("TOP", FrameName, "TOP", 0, self.db.char.barfontsize + 2)
	FrameName:SetScript("OnUpdate", 
		function()
				if combat == true or self.db.char.showcombat == false then
					Watcher.priorityTable.check[self.db.char.priority.option[optionnum]](FrameName, optionnum)
				end
		end	);	
	if self.db.char.showcombat == true then
		if combat == true then
			FrameName:Show()
		else
			FrameName:Hide()
		end
	else
		FrameName:Show()
	end
	if self.db.char.priority.iconcd then
		FrameName.Text:Show()
	else
		FrameName.Text:Hide()
	end
end


function Watcher:ResetPriority()
	self.PriorityFrame:ClearAllPoints()
	self.db.char.priority.point = self.defaults.char.priority.point
	self.db.char.priority.relativeTo = self.defaults.char.priority.relativeTo 
	self.db.char.priority.relativePoint = self.defaults.char.priority.relativePoint
	self.db.char.priority.xOffset = self.defaults.char.priority.xOffset
	self.db.char.priority.yOffset = self.defaults.char.priority.yOffset
	Watcher.db.char.priority.fWidth = self.defaults.char.priority.fWidth
	self.db.char.priority.fHeight = self.defaults.char.priority.fHeight
	self.db.char.scale = self.defaults.char.priority.scale
	self.db.char.priority.option = self.defaults.char.priority.option
	self.PriorityFrame:SetPoint(self.db.char.priority.point, self.db.char.priority.relativeTo, self.db.char.priority.relativePoint, self.db.char.priority.xOffset, self.db.char.priority.yOffset)
	self:CreatePriorityFrame()
	self:Print(L["priority_reset"])
end
